## ddnet 16.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12...3.19.1)
if(CMAKE_VERSION VERSION_LESS 3.12)
  cmake_policy(VERSION ${CMAKE_VERSION})
endif()

set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13 CACHE INTERNAL "")
if(CMAKE_OSX_DEPLOYMENT_TARGET VERSION_LESS 10.13)
  message(WARNING "Building for macOS < 10.13 is not supported")
endif()

file(STRINGS src/game/version.h VERSION_LINE
  LIMIT_COUNT 1
  REGEX "^#define GAME_RELEASE_VERSION "
)

if(VERSION_LINE MATCHES "\"([0-9]+)\\.([0-9]+)\\.([0-9]+)\"")
  set(VERSION_MAJOR ${CMAKE_MATCH_1})
  set(VERSION_MINOR ${CMAKE_MATCH_2})
  set(VERSION_PATCH ${CMAKE_MATCH_3})
elseif(VERSION_LINE MATCHES "\"([0-9]+)\\.([0-9]+)\"")
  set(VERSION_MAJOR ${CMAKE_MATCH_1})
  set(VERSION_MINOR ${CMAKE_MATCH_2})
  set(VERSION_PATCH "0")
else()
  message(FATAL_ERROR "Couldn't parse version from src/game/version.h")
endif()

# Extra support for CMake pre-3.0
if(NOT POLICY CMP0048)
  set(PROJECT_VERSION_MAJOR ${VERSION_MAJOR})
  set(PROJECT_VERSION_MINOR ${VERSION_MINOR})
  set(PROJECT_VERSION_PATCH ${VERSION_PATCH})
  if(VERSION_PATCH STREQUAL "0")
    set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
  else()
    set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
  endif()
endif()
if(VERSION_PATCH STREQUAL "0")
  project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
else()
  project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
endif()

set(ORIGINAL_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH})
set(ORIGINAL_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
set(ORIGINAL_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
set(OWN_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
set(CMAKE_MODULE_PATH ${OWN_CMAKE_MODULE_PATH})

if(CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(TARGET_BITS "32")
else()
  set(TARGET_BITS "64")
endif()

if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "arm" OR "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "aarch64")
  if(TARGET_BITS STREQUAL "32")
    set(TARGET_CPU_ARCHITECTURE "arm")
  else()
    set(TARGET_CPU_ARCHITECTURE "arm64")
  endif()
else()
  if(TARGET_BITS STREQUAL "32")
    set(TARGET_CPU_ARCHITECTURE "x86")
  else()
    set(TARGET_CPU_ARCHITECTURE "x86_64")
  endif()
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  set(TARGET_OS "windows")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  set(TARGET_OS "linux")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(TARGET_OS "mac")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Haiku")
  set(TARGET_OS "haiku")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Android")
  set(TARGET_OS "android")
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.18)
  include(CheckLinkerFlag)
endif()
include(CheckSymbolExists)
if(NOT (CMAKE_SYSTEM_NAME STREQUAL "Emscripten"))
  include(CheckAtomic)
endif()

check_symbol_exists(__i386 "" TARGET_ARCH_X86_i386)
if(TARGET_ARCH_X86_i386)
  set(TARGET_ARCH x86)
else()
  set(TARGET_ARCH)
endif()

set(AUTO_DEPENDENCIES_DEFAULT OFF)

set(AUTO_VULKAN_BACKEND ON)
if(TARGET_OS STREQUAL "windows")
  set(AUTO_DEPENDENCIES_DEFAULT ON)
  if(TARGET_CPU_ARCHITECTURE STREQUAL "x86")
    set(AUTO_VULKAN_BACKEND OFF)
  endif()
elseif(TARGET_OS STREQUAL "mac")
  set(AUTO_VULKAN_BACKEND OFF)
endif()

option(WEBSOCKETS "Enable websockets support" OFF)
option(MYSQL "Enable mysql support" OFF)
option(TEST_MYSQL "Test mysql support in unit tests (also sets -DMYSQL=ON)" OFF)
option(AUTOUPDATE "Enable the autoupdater" OFF)
option(INFORM_UPDATE "Inform about available updates" ON)
option(VIDEORECORDER "Enable video recording support via FFmpeg" ON)
option(UPNP "Enable UPnP support" OFF)
option(ANTIBOT "Enable support for a dynamic anticheat library" OFF)
option(HEADLESS_CLIENT "Build the client without graphics" OFF)
option(CLIENT "Compile client" ON)
option(SERVER "Compile server" ON)
option(TOOLS "Compile tools" ON)
option(DOWNLOAD_GTEST "Download and compile GTest" ${AUTO_DEPENDENCIES_DEFAULT})
option(STEAM "Build the Steam release version" OFF)
option(DISCORD "Enable Discord rich presence support" OFF)
option(DISCORD_DYNAMIC "Enable discovering Discord rich presence libraries at runtime (Linux only)" OFF)
option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})
option(DEV "Don't generate stuff necessary for packaging" OFF)
option(VULKAN "Enable the vulkan backend" ${AUTO_VULKAN_BACKEND})

option(EXCEPTION_HANDLING "Enable exception handling (only works with Windows as of now)" OFF)
option(IPO "Enable interprocedural optimizations" OFF)
option(FUSE_LD "Linker to use" OFF)

if(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  include(${PROJECT_SOURCE_DIR}/cmake/toolchains/Emscripten.toolchain)
endif()

if(TEST_MYSQL)
  set(MYSQL ON)
endif()

# Set version if not explicitly set
if(NOT VERSION)
  set(VERSION ${PROJECT_VERSION})
endif()

set(OpenGL_GL_PREFERENCE LEGACY)

# Set the default build type to Release
if(NOT(CMAKE_BUILD_TYPE))
  if(NOT(DEV))
    set(CMAKE_BUILD_TYPE Release)
  else()
    set(CMAKE_BUILD_TYPE Debug)
  endif()
endif()

if(NOT(CMAKE_BUILD_TYPE MATCHES "^(Release|Debug|RelWithDebInfo|MinSizeRel)$"))
  message(WARNING "Unknown CMAKE_BUILD_TYPE, should be one of Release, Debug, RelWithDebInfo or MinSizeRel")
endif()

set(DBG $<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>)

if(IPO)
  if(CMAKE_VERSION VERSION_GREATER 3.9)
    include(CheckIPOSupported)
    check_ipo_supported(RESULT ipo_supported OUTPUT ipo_output)
    if(ipo_supported)
      message(STATUS "IPO is enabled")
      set(ENABLE_IPO TRUE)
    else()
      message(WARNING "IPO is not supported: ${ipo_output}")
    endif()
  else()
      message(WARNING "IPO enablement requires CMake 3.9+")
  endif()
endif()

if(CMAKE_VERSION VERSION_LESS 3.0)
  configure_file(src/game/version.h vd.h)
else()
  set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
    src/game/version.h
  )
endif()

set(SERVER_EXECUTABLE DDNet-Server CACHE STRING "Name of the built server executable")
set(CLIENT_EXECUTABLE DDNet CACHE STRING "Name of the build client executable")

########################################################################
# Compiler flags
########################################################################

function(add_c_compiler_flag_if_supported VARIABLE FLAG)
  if(ARGC GREATER 2)
    set(CHECKED_FLAG "${ARGV2}")
  else()
    set(CHECKED_FLAG "${FLAG}")
  endif()
  string(REGEX REPLACE "[^A-Za-z0-9]" "_" CONFIG_VARIABLE "FLAG_SUPPORTED${CHECKED_FLAG}")
  check_c_compiler_flag("${CHECKED_FLAG}" ${CONFIG_VARIABLE})
  if(${CONFIG_VARIABLE})
    if(${VARIABLE})
      set("${VARIABLE}" "${${VARIABLE}};${FLAG}" PARENT_SCOPE)
    else()
      set("${VARIABLE}" "${FLAG}" PARENT_SCOPE)
    endif()
  endif()
endfunction()

function(add_cxx_compiler_flag_if_supported VARIABLE FLAG)
  if(ARGC GREATER 2)
    set(CHECKED_FLAG "${ARGV2}")
  else()
    set(CHECKED_FLAG "${FLAG}")
  endif()
  string(REGEX REPLACE "[^A-Za-z0-9]" "_" CONFIG_VARIABLE "FLAG_SUPPORTED${CHECKED_FLAG}")
  check_cxx_compiler_flag("${CHECKED_FLAG}" ${CONFIG_VARIABLE})
  if(${CONFIG_VARIABLE})
    if(${VARIABLE})
      set("${VARIABLE}" "${${VARIABLE}};${FLAG}" PARENT_SCOPE)
    else()
      set("${VARIABLE}" "${FLAG}" PARENT_SCOPE)
    endif()
  endif()
endfunction()

function(add_linker_flag_if_supported VARIABLE FLAG)
  if(ARGC GREATER 2)
    set(CHECKED_FLAG "${ARGV2}")
  else()
    set(CHECKED_FLAG "${FLAG}")
  endif()
  string(REGEX REPLACE "[^A-Za-z0-9]" "_" CONFIG_VARIABLE "FLAG_SUPPORTED${CHECKED_FLAG}")
  if(CMAKE_VERSION VERSION_LESS 3.18)
    set(${CONFIG_VARIABLE} OFF)
  else()
    check_linker_flag(C "${CHECKED_FLAG}" ${CONFIG_VARIABLE})
  endif()
  if(${CONFIG_VARIABLE})
    if(${VARIABLE})
      set("${VARIABLE}" "${${VARIABLE}};${FLAG}" PARENT_SCOPE)
    else()
      set("${VARIABLE}" "${FLAG}" PARENT_SCOPE)
    endif()
  endif()
endfunction()

# Force compiler colors on when using ninja. Ninja filters the colors out when
# it's not printing to a terminal on its own.
if(CMAKE_GENERATOR STREQUAL "Ninja")
  add_cxx_compiler_flag_if_supported(OUR_FLAGS -fdiagnostics-color=always)
  add_cxx_compiler_flag_if_supported(OUR_FLAGS -fcolor-diagnostics)
endif()

if(NOT MSVC AND NOT HAIKU)
  IF(NOT TARGET_OS STREQUAL "mac")
    if(NOT FUSE_LD STREQUAL OFF)
      add_linker_flag_if_supported(OUR_FLAGS_LINK -fuse-ld=${FUSE_LD})
      if(FLAG_SUPPORTED_fuse_ld_${FUSE_LD})
        message(STATUS "Using ${FUSE_LD} linker")
      endif()
    else()
      if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR NOT ENABLE_IPO)
        # GCC+LTO: pthread_create has failed: Resource temporarily unavailable
        add_linker_flag_if_supported(OUR_FLAGS_LINK -fuse-ld=mold)
        if(FLAG_SUPPORTED_fuse_ld_mold)
          message(STATUS "Using mold linker")
        else()
          # Does not support GCC+LTO
          add_linker_flag_if_supported(OUR_FLAGS_LINK -fuse-ld=lld)
          if(FLAG_SUPPORTED_fuse_ld_lld)
            message(STATUS "Using lld linker")
          else()
            add_linker_flag_if_supported(OUR_FLAGS_LINK -fuse-ld=gold)
            if(FLAG_SUPPORTED_fuse_ld_gold)
              message(STATUS "Using gold linker")
            endif()
          endif()
        endif()
      else()
        add_linker_flag_if_supported(OUR_FLAGS_LINK -fuse-ld=gold)
        if(FLAG_SUPPORTED_fuse_ld_gold)
          message(STATUS "Using gold linker")
        endif()
      endif()
    endif()
  endif()

  if(CMAKE_VERSION VERSION_LESS 3.1 OR TARGET_OS STREQUAL "mac")
    add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -std=gnu++17)
  endif()

  # Protect the stack pointer.
  # -fstack-protector-all doesn't work on MinGW.
  add_cxx_compiler_flag_if_supported(OUR_FLAGS -fstack-protector-all)

  # Disable exceptions as DDNet does not use them.
  add_cxx_compiler_flag_if_supported(OUR_FLAGS -fno-exceptions)

  # Inaccurate floating point numbers cause problems on mingw-w64-gcc when
  # compiling for x86, might cause problems elsewhere. So don't store floats
  # in registers but keep them at higher accuracy.
  if(TARGET_ARCH STREQUAL "x86")
    add_cxx_compiler_flag_if_supported(OUR_FLAGS -ffloat-store)
  endif()

  # Don't insert timestamps into PEs to keep the build reproducible.
  if(TARGET_OS STREQUAL "windows")
    add_cxx_compiler_flag_if_supported(OUR_FLAGS_LINK -Wl,--no-insert-timestamp)
  endif()

  if(TARGET_OS STREQUAL "mac")
    add_cxx_compiler_flag_if_supported(OUR_FLAGS -stdlib=libc++)
  endif()

  if(EXCEPTION_HANDLING)
    add_cxx_compiler_flag_if_supported(OUR_FLAGS -DCONF_EXCEPTION_HANDLING)
    # use the frame pointer (frame pointer usage is disabled by default in
    # some architectures like x86_64 and for some optimization levels; and it
    # may be impossible to walk the call stack without it)
    add_cxx_compiler_flag_if_supported(OUR_FLAGS -fno-omit-frame-pointer)
  endif()

  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wall)
  if(CMAKE_VERSION VERSION_GREATER 3.3 OR CMAKE_VERSION VERSION_EQUAL 3.3)
    add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN
      $<$<COMPILE_LANGUAGE:C>:-Wdeclaration-after-statement>
      -Wdeclaration-after-statement
    )
  endif()
  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wextra)
  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-unused-parameter)
  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-missing-field-initializers)
  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wformat=2) # Warn about format strings.
  add_c_compiler_flag_if_supported(OUR_FLAGS_DEP -Wno-implicit-function-declaration)
  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-nullability-completeness) # Mac OS build on github
  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-cond)
  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-branches)
  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wlogical-op)
  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wrestrict)

=== debian/changelog ===
ddnet (16.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable another test that accesses the internet.
    (Closes: #1028113)
  * Add needs-internet to the autopkgtest.

 -- Adrian Bunk <bunk@debian.org>  Sun, 12 Feb 2023 17:42:25 +0200

ddnet (16.4-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.1

 -- Yangfl <mmyangfl@gmail.com>  Tue, 11 Oct 2022 05:55:07 +0800

=== debian/control ===
Source: ddnet
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 SZ Lin (林上智) <szlin@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 cmake,
 python3:native,
 libcurl4-openssl-dev,
 libfreetype6-dev,
 libogg-dev,
 libopus-dev,
 libopusfile-dev,
 libsdl2-dev,
 libmariadb-dev,
 libmysqlcppconn-dev,
 libboost-dev,
 libglew-dev,
 libwavpack-dev,
 libjsonparser-dev,
 libgtest-dev <!nocheck>,
 libgmock-dev <!nocheck>,
 libnotify-dev,
 libsqlite3-dev,
 libvulkan-dev,
 glslang-tools,
 libx264-dev,
 libavformat-dev,
 libswresample-dev,
 libswscale-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://ddnet.tw/
Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
Vcs-Browser: https://salsa.debian.org/games-team/ddnet

Package: ddnet
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ddnet-data (>= ${source:Version}),
Description: Teeworlds modification with a unique cooperative gameplay
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the client binary for DDNet.

Package: ddnet-server
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ddnet-data (>= ${source:Version}),
Suggests:
 ddnet-tools,
Description: Server for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the server binary for DDNet.

Package: ddnet-tools
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Tools for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains tools for DDNet maps and configs.

Package: ddnet-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 fonts-dejavu-core,
Recommends:
 fonts-noto-cjk,
Description: Data for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the static data for DDNet.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O3
export DEB_LDFLAGS_MAINT_APPEND =

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH),ia64)
  # gcc o3 segfault on ia64
  # It's just annoying, not a sign I'll care about ia64
  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
endif


%:
	dh $@

build-indep:
	# pass

execute_after_dh_auto_clean-indep:
	$(RM) -r datasrc/__pycache__ datasrc/seven/__pycache__

override_dh_auto_configure-arch:
	dh_auto_configure -a -- \
		-DMYSQL=ON -DAUTOUPDATE=OFF \
		-DTESTRUNNER_ARGS=--gtest_filter=-Jobs.LookupHost:Jobs.LookupHostWebsocket

override_dh_auto_test-arch:
	+cd obj-$(DEB_BUILD_GNU_TYPE) && make run_tests

override_dh_auto_install-indep:
	for px in 16 32 48 128 256 512; do \
		size=$${px}x$${px}; \
		fn=other/icons/DDNet_$${size}x32.png; \
		if [ -f $${fn} ]; then \
			dir=debian/tmp/usr/share/icons/hicolor/$${size}/apps/; \
			mkdir -p $${dir}; \
			cp $${fn} $${dir}/ddnet.png; \
		fi; \
	done;

execute_after_dh_install-indep:
	for f in assets/entities/license.txt languages/license.txt maps/license.txt skins/license.txt; do \
		$(RM) "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
	done

=== debian/tests/control ===
Tests: unittest.sh
Depends: @builddeps@
Restrictions: allow-stderr, needs-internet

## ddnet 19.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,8 @@
-cmake_minimum_required(VERSION 2.8.12...3.19.1)
-if(CMAKE_VERSION VERSION_LESS 3.12)
-  cmake_policy(VERSION ${CMAKE_VERSION})
-endif()
-
-set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13 CACHE INTERNAL "")
-if(CMAKE_OSX_DEPLOYMENT_TARGET VERSION_LESS 10.13)
-  message(WARNING "Building for macOS < 10.13 is not supported")
+cmake_minimum_required(VERSION 3.12...3.27.4)
+
+set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15 CACHE INTERNAL "Minimum macOS deployment version")
+if(CMAKE_OSX_DEPLOYMENT_TARGET VERSION_LESS 10.15)
+  message(WARNING "Building for macOS < 10.15 is not supported")
 endif()
 
 file(STRINGS src/game/version.h VERSION_LINE
@@ -25,17 +22,6 @@
   message(FATAL_ERROR "Couldn't parse version from src/game/version.h")
 endif()
 
-# Extra support for CMake pre-3.0
-if(NOT POLICY CMP0048)
-  set(PROJECT_VERSION_MAJOR ${VERSION_MAJOR})
-  set(PROJECT_VERSION_MINOR ${VERSION_MINOR})
-  set(PROJECT_VERSION_PATCH ${VERSION_PATCH})
-  if(VERSION_PATCH STREQUAL "0")
-    set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
-  else()
-    set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
-  endif()
-endif()
 if(VERSION_PATCH STREQUAL "0")
   project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
 else()
@@ -54,7 +40,9 @@
   set(TARGET_BITS "64")
 endif()
 
-if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "arm" OR "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "aarch64")
+if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "arm"
+  OR "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "aarch64"
+  OR "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "ARM64")
   if(TARGET_BITS STREQUAL "32")
     set(TARGET_CPU_ARCHITECTURE "arm")
   else()
@@ -116,7 +104,7 @@
 option(INFORM_UPDATE "Inform about available updates" ON)
 option(VIDEORECORDER "Enable video recording support via FFmpeg" ON)
 option(UPNP "Enable UPnP support" OFF)
-option(ANTIBOT "Enable support for a dynamic anticheat library" OFF)
+option(ANTIBOT "Enable support for a dynamic anticheat library (not provided, see src/antibot for interface if you want to implement your own)" OFF)
 option(HEADLESS_CLIENT "Build the client without graphics" OFF)
 option(CLIENT "Compile client" ON)
 option(SERVER "Compile server" ON)
@@ -132,6 +120,7 @@
 option(EXCEPTION_HANDLING "Enable exception handling (only works with Windows as of now)" OFF)
 option(IPO "Enable interprocedural optimizations" OFF)
 option(FUSE_LD "Linker to use" OFF)
+option(SECURITY_COMPILER_FLAGS "Whether to set security-relevant compiler flags like -D_FORTIFY_SOURCE=2 and -fstack-protector-strong" ON)
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
   include(${PROJECT_SOURCE_DIR}/cmake/toolchains/Emscripten.toolchain)
@@ -164,26 +153,19 @@
 set(DBG $<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>)
 
 if(IPO)
-  if(CMAKE_VERSION VERSION_GREATER 3.9)
-    include(CheckIPOSupported)
-    check_ipo_supported(RESULT ipo_supported OUTPUT ipo_output)
-    if(ipo_supported)
-      message(STATUS "IPO is enabled")
-      set(ENABLE_IPO TRUE)
-    else()
-      message(WARNING "IPO is not supported: ${ipo_output}")
-    endif()
-  else()
-      message(WARNING "IPO enablement requires CMake 3.9+")
-  endif()
-endif()
-
-if(CMAKE_VERSION VERSION_LESS 3.0)
-  configure_file(src/game/version.h vd.h)
-else()
-  set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
-    src/game/version.h
-  )
+  include(CheckIPOSupported)
+  check_ipo_supported(RESULT ipo_supported OUTPUT ipo_output)
+  if(ipo_supported)
+    message(STATUS "IPO is enabled")
+    set(ENABLE_IPO TRUE)
+  else()
+    message(WARNING "IPO is not supported: ${ipo_output}")
+  endif()
+endif()
+
+if(NOT "${CMAKE_CURRENT_BINARY_DIR}" STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")
+  # Remove version.h generated by previous build code
+  file(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/src/game/version.h)
 endif()
 
 set(SERVER_EXECUTABLE DDNet-Server CACHE STRING "Name of the built server executable")
@@ -256,7 +238,7 @@
 endif()
 
 if(NOT MSVC AND NOT HAIKU)
-  IF(NOT TARGET_OS STREQUAL "mac")
+  if(NOT TARGET_OS STREQUAL "mac")
     if(NOT FUSE_LD STREQUAL OFF)
       add_linker_flag_if_supported(OUR_FLAGS_LINK -fuse-ld=${FUSE_LD})
       if(FLAG_SUPPORTED_fuse_ld_${FUSE_LD})
@@ -289,13 +271,17 @@
     endif()
   endif()
 
-  if(CMAKE_VERSION VERSION_LESS 3.1 OR TARGET_OS STREQUAL "mac")
+  if(TARGET_OS STREQUAL "mac")
     add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -std=gnu++17)
   endif()
 
-  # Protect the stack pointer.
-  # -fstack-protector-all doesn't work on MinGW.
-  add_cxx_compiler_flag_if_supported(OUR_FLAGS -fstack-protector-all)
+  if(SECURITY_COMPILER_FLAGS)
+    # Protect the stack pointer.
+    add_cxx_compiler_flag_if_supported(OUR_FLAGS -fstack-protector-strong)
+    if(MINGW)
+      add_linker_flag_if_supported(OUR_FLAGS_LINK -lssp)
+    endif()
+  endif()
 
   # Disable exceptions as DDNet does not use them.
   add_cxx_compiler_flag_if_supported(OUR_FLAGS -fno-exceptions)
@@ -306,6 +292,11 @@
   if(TARGET_ARCH STREQUAL "x86")
     add_cxx_compiler_flag_if_supported(OUR_FLAGS -ffloat-store)
   endif()
+
+  # We assume that char is signed in various places in the code. In particular,
+  # the Str.StrToInts test will fail when char is not signed and names containing
+  # special characters will be displayed incorrectly on servers.
+  add_cxx_compiler_flag_if_supported(OUR_FLAGS -fsigned-char)
 
   # Don't insert timestamps into PEs to keep the build reproducible.
   if(TARGET_OS STREQUAL "windows")
@@ -325,19 +316,13 @@
   endif()
 
   add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wall)
-  if(CMAKE_VERSION VERSION_GREATER 3.3 OR CMAKE_VERSION VERSION_EQUAL 3.3)
-    add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN
-      $<$<COMPILE_LANGUAGE:C>:-Wdeclaration-after-statement>
-      -Wdeclaration-after-statement
-    )
-  endif()
   add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wextra)
+  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-psabi) # parameter passing for argument of type ‘__gnu_cxx::__normal_iterator<CCommandProcessorFragment_Vulkan::SMemoryBlock<1>*, std::vector<CCommandProcessorFragment_Vulkan::SMemoryBlock<1>, std::allocator<CCommandProcessorFragment_Vulkan::SMemoryBlock<1> > > >’ changed in GCC 7.1
   add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-unused-parameter)
   add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-missing-field-initializers)
-  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wformat=2) # Warn about format strings.
+  if(CMAKE_BUILD_TYPE STREQUAL DEBUG)
+    add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wformat=2) # Warn about format strings.
+  else()
+    add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-format) # Don't warn about format strings in release mode since our `str_format` optimization is incompatible with it.
+  endif()
   add_c_compiler_flag_if_supported(OUR_FLAGS_DEP -Wno-implicit-function-declaration)
-  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-nullability-completeness) # Mac OS build on github
-  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-cond)
-  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-branches)
-  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wlogical-op)
-  add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN -Wrestrict)

=== debian/changelog ===
ddnet (19.1-2) unstable; urgency=medium

  * Team upload.
  * Clear Cargo.lock completelty (Closes: #1102780)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 16 Apr 2025 13:04:36 +0200

ddnet (19.1-1) unstable; urgency=medium

  * Team Upload
  * New Upstream release (Closes: #1072409)
  * Add SDL2 and a lot of new Rust build dependencies
  * Disable autopkgtest that was not quite one (Closes: #1032567)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 05 Apr 2025 20:40:41 +0200

ddnet (16.4-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Fix build with GCC-13. (Closes: #1037618)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 05 Aug 2023 15:40:19 +0200

=== debian/control ===
--- 
+++ 
@@ -8,42 +8,54 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Arch:
+ cargo,
  cmake,
- python3:native,
+ glslang-tools,
+ libavformat-dev,
+ libboost-dev,
  libcurl4-openssl-dev,
- libfreetype6-dev,
+ libfreetype-dev,
+ libglew-dev,
+ libgmock-dev <!nocheck>,
+ libgtest-dev <!nocheck>,
+ libjsonparser-dev,
+ libmariadb-dev,
+ libmysqlcppconn-dev,
+ libnotify-dev,
  libogg-dev,
  libopus-dev,
  libopusfile-dev,
+ librust-cc-dev,
+ librust-cxx-dev,
+ librust-cxx-build-dev,
+ librust-cxxbridge-flags-dev,
+ librust-cxxbridge-macro-dev,
+ librust-link-cplusplus-dev,
+ librust-proc-macro2-dev,
+ librust-quote-dev,
+ librust-syn-dev,
+ librust-unicode-ident-dev,
  libsdl2-dev,
- libmariadb-dev,
- libmysqlcppconn-dev,
- libboost-dev,
- libglew-dev,
- libwavpack-dev,
- libjsonparser-dev,
- libgtest-dev <!nocheck>,
- libgmock-dev <!nocheck>,
- libnotify-dev,
  libsqlite3-dev,
- libvulkan-dev,
- glslang-tools,
- libx264-dev,
- libavformat-dev,
  libswresample-dev,
  libswscale-dev,
+ libvulkan-dev,
+ libwavpack-dev,
+ libx264-dev,
+ python3:native,
 Rules-Requires-Root: no
 Standards-Version: 4.6.1
 Homepage: https://ddnet.tw/
 Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
 Vcs-Browser: https://salsa.debian.org/games-team/ddnet
+X-Style: black
 
 Package: ddnet
 Architecture: any
 Depends:
+ ddnet-data (>= ${source:Version}),
+ ${misc:Depends},
  ${shlibs:Depends},
- ${misc:Depends},
- ddnet-data (>= ${source:Version}),
 Description: Teeworlds modification with a unique cooperative gameplay
  DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
  modification with a unique cooperative gameplay. Help each other play through
@@ -55,9 +67,9 @@
 Package: ddnet-server
 Architecture: any
 Depends:
+ ddnet-data (>= ${source:Version}),
+ ${misc:Depends},
  ${shlibs:Depends},
- ${misc:Depends},
- ddnet-data (>= ${source:Version}),
 Suggests:
  ddnet-tools,
 Description: Server for DDNet
@@ -70,9 +82,10 @@
 
 Package: ddnet-tools
 Architecture: any
+Multi-Arch: same
 Depends:
+ ${misc:Depends},
  ${shlibs:Depends},
- ${misc:Depends},
 Description: Tools for DDNet
  DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
  modification with a unique cooperative gameplay. Help each other play through
@@ -85,8 +98,8 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
+ fonts-dejavu-core,
  ${misc:Depends},
- fonts-dejavu-core,
 Recommends:
  fonts-noto-cjk,
 Description: Data for DDNet

=== debian/rules ===
--- 
+++ 
@@ -1,19 +1,17 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE = 1
 
+export CARGO_NET_OFFLINE=true
+export CARGO_HOME=$(shell pwd)/debian/cargo_home
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O3
+export DEB_CXXFLAGS_MAINT_APPEND = -Wno-variadic-macros
+#-Wall -pedantic -O3
+
 export DEB_LDFLAGS_MAINT_APPEND =
 
 include /usr/share/dpkg/architecture.mk
-
-ifeq ($(DEB_HOST_ARCH),ia64)
-  # gcc o3 segfault on ia64
-  # It's just annoying, not a sign I'll care about ia64
-  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
-endif
 
 
 %:
@@ -23,12 +21,12 @@
 	# pass
 
 execute_after_dh_auto_clean-indep:
-	$(RM) -r datasrc/__pycache__ datasrc/seven/__pycache__
+	$(RM) -r datasrc/__pycache__ datasrc/seven/__pycache__ debian/cargo_home/.global-cache
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -a -- \
 		-DMYSQL=ON -DAUTOUPDATE=OFF \
-		-DTESTRUNNER_ARGS=--gtest_filter=-Jobs.LookupHost:Jobs.LookupHostWebsocket
+		-DTESTRUNNER_ARGS=--gtest_filter=-Jobs.LookupHost
 
 override_dh_auto_test-arch:
 	+cd obj-$(DEB_BUILD_GNU_TYPE) && make run_tests
